#!/bin/bash
##########################################################
# good ref: http://tldp.org/LDP/abs/html/comparison-ops.html




# in bash every variable is string type.
# there is no true/false boolean type.
# aternatively, we can do:
# "${go}" = "true" is the string comparison.
go="false"
if [ "${go}" = "true" ]; then 
    echo "123" 
fi

# syntax note:
# the 'if' and '[' should has a space.
# if[ "${go}" = "true" ]; then, would not work.
# the "true" and ']' should has a space.
# if [ "${go}" = "true"]; then, would not work.
# ';' is the statment end.
# so we can do
# if [ "${go}" = "true" ] 
#     then 
#     echo "123" 
# fi

#########################################################
#
# to use (( )) 
# for  arithmetic expression

var="1"  # or we can simply do var=1
go="false"
if [ "${go}" = "true" ]; then 
    
    if ((var>0));then

        echo "var is positive"
    
    elif ((var==0)); then
        
        echo "var is 0"
    
    else
        echo "var is neative"
    fi

fi


########################################################
#
# use [ ] 
# it is the older Fortran-style comparison.
# -gt ==> >
# -eg ==> ==

var="0"
go="false"
if [ "${go}" = "true" ]; then 

    if [ $var -gt 0 ]; then
        echo "var is positive"
    elif [ $var -eq 0 ]; then
        echo "var is 0"
    else
        echo "var is negative"
    fi
fi 
    

#########################################################

# to check the file/dir exist or not
# -d folder ( true for folder exists. )
# -e file   ( true for file   exists. )

go="false"
dir="/home/xination/Dropbox/3_my_program/demo_bash"
file=$dir"/01_if_statement.sh"
if [ "${go}" = "true" ]; then 

    if [ -d "$dir" ]; then
        echo "$dir exists"
    fi

    if [ -e "$file" ]; then
        echo "$file exists"
    fi
fi 

 





#########################################################
# test whether our argument is zero length.
# -z is to test whether a string = "" empty.
# 

go="false"
aString=""
aString1="123"
aString2="123"
aString3="---123---"
if [ "${go}" = "true" ]; then 

    if [ -z "$aString" ]; then
        echo "string is empty"
    fi

    if [ ! -z "$aString1" ]; then
        echo "string is NOT empty"
    fi

    if [ "$aString1" = "$aString2" ]; then
        echo "two string is the same"
    fi

    # * will be expanded to anything.
    # it is a trick to let us seartch whether
    # string3 contains string1.
    # since we use expansion, we need [[ ]], instead of [ ]
    if [[ "{$aString3}" = *"${aString1}"* ]]; then
        echo "$aString3 contains $aString1"
    fi
     
fi 
 

#########################################################
#  composited conditions
# 

go="true"
aString="pdf"

if [ "${go}" = "true" ]; then 

	# or  condition by || 
	# and condition by &&
	if [ "${aString}" = "p" ] || [ "${aString}" = "pdf" ]; then     
	  echo ${aString}
    fi
     
fi 
 

 
 
