#!/bin/bash
 
myArray=("1" a  2017 ) 
# the array initialization: 
# we don't need to set its size first
# and it use space as deliminator, not use ','
# the array can be expand by ${myArray[@]}
# [@] is the key to expand an array.
# the array size is ${#myArray[@]}
# # is the key to get the size of an array.
 go="false"

 if [ "$go" = "true" ]; then

    echo "whole array = ${myArray[@]}"
    echo "================="
    
    # loop an array
    for item in ${myArray[@]}; do
     	echo "item = $item" 
    done

    echo "================="
    echo "array size = ${#myArray[@]}"
    # loop an array method 2
    for(( i=0; i< ${#myArray[@]}; i++  )); do
        echo "${i}th item = ${myArray[ (($i)) ]}" 
        #
        # (($1)) is to use arithmetic experssion to get the int i (not string i)
        # ${myArray[ idx  ]} is to get the idx-th of an array.
        #
    done
    
 fi


#===================================================
# concaternate two arrays.
#
# arr1=( 1 2 3 )
# arr2=( 4 5 6 )
# whole_array=( ${arr1[@]} ${arr2[@]} ) 
 
 
  
go="false"

 if [ "$go" = "true" ]; then

    arr1=( 1 2 3 )
    arr2=( 4 5 6 )
    
    whole_array=( ${arr1[@]}  ${arr2[@]} )  
    # we initialize whole_array by two arrays (arr1 and arr2)
    # '=' and '(' should have no space.
    # whole_array=( ${arr1[@]}  ${arr2[@]} )  
    # whole_array= ( ${arr1[@]}  ${arr2[@]} )  not work.
    # whole_array =( ${arr1[@]}  ${arr2[@]} )  not work.

    # loop an array
    for item in ${whole_array[@]}; do
        echo $item 
    done
    
 fi



#======================================================
# change the array's element
go="true"
if [ "$go" = "true" ]; then

    arr=( 1 2 3 )
     
    echo "----------------"
    for(( i=0; i< ${#arr[@]}; i++  )); do
        arr[ (($i)) ]=$(( ${arr[ (($i)) ]} + 1 ))
        #
        # $(( )) is for arithmetic expression.
        #
        echo "${arr[ (($i)) ]}"        
    done

fi



#=================================================== 
# get an array from ls
go="false"

if [ "$go" = "true" ]; then

    arr=( $(ls ./ ) )
    echo -e "the array:\n${arr[@]}\n "
    echo "----------------------------"
    echo "array size = ${#arr[@]}"
    #================================
    # loop an array
    echo "----------------"
    for(( i=0; i< ${#arr[@]}; i++  )); do
        echo "${i}th item = ${arr[ (($i)) ]}"        
    done

fi


#======================================================
# get an array from ps aux, and only show the column2 and 11
go="false"

if [ "$go" = "true" ]; then

    arr_PID=( $(ps aux | awk '{print $2}') )
    arr_cmd=( $(ps aux | awk '{print $11}') )
    echo "----------------------------"
    echo "PID array size = ${#arr_PID[@]}"
    #================================
    # loop an array
    echo "----------------"
    for(( i=0; i< ${#arr_PID[@]}; i++  )); do
        echo "${i}th PID = ${arr_PID[ (($i)) ]} cmd =  ${arr_cmd[ (($i)) ]}"        
    done

fi