#!/bin/bash
#
# the script in general is slow. and sometime it can run over maxcore.
# due to it cannot synchromize...
source /home/xination/1_Research/root-5.34.36/bin/thisroot.sh

function my_exe () {

   
    # to get raw root 
    root -q -l ./Tai_script/convert_and_calibrate.C\(${runs},1,0,0\)

    # to get hira cal root ( apply calibration parameters to raw data).
    # the calibration file is set at loadExp.C
    # root -q -l ./Tai_script/convert_and_calibrate.C\(${runs},0,1,0\)

    # to make sure we correct the filename.
    # DIR="/home/xination/Dropbox/7_hira/code/mytools"
    # ${DIR}/changeCalFileName.py 2>/dev/null 1>/dev/null

    # get pri root ( collect data )
    # root -q -l ./Tai_script/convert_and_calibrate.C\(${runs},0,0,1\)


    #================================================================
    # from raw to s800 cal root ( apply calibration parameters )
    # root -q -l ./Tai_script/s800_and_calculate.C\($runs\)

    # to convert brief_s800 root ( collect data )
    # root -q -l Tai_script/HiRA_analysis/s800_branch_recreate.C\($runs,0\)



    #================================================================
    # to Tai root ( merge HiRA and S800)
    # root -q  -l Tai_script/HiRA_analysis/analysis_main.C\($runs\)

}



function check_PID() {

    # the first argument to the function is PID
    PID_input=$1

    # use awk 'print $2' to get second field of result from 'ps aux'
    # and then we search whether PID_input is in PID_LIST. 
    search_result=$(ps aux | awk '{print $2}' | grep -w $PID_input )

    
    if [ -z "$search_result" ];
    then
        echo "done"
    else
        echo "still_going"
    fi

}


MAXCORE=8    # change to higher number to faster the process
PID[$MAXCORE]=0
NPROC=0
TO_SEE=1

# good 86Kr data runs:
kr_set1=(176 178 179 180 181 182 183 184 185 186 187)
kr_set2=(188 189 190 191 192 193 194 195 196)
kr_set3=(402 405 406 409 410)
kr_set4=(417 418 419 420 421 \
        422 423 424 425 427 \
        428 429 430 431 432 \
        433 435 442 444)
kr_all=(${kr_set1[@]} ${kr_set2[@]} ${kr_set3[@]}  ${kr_set4[@]})

start_time=`date +%s`
for runs in  192 ${kr_set1[@]} 422 
 
             
do
    echo "======================= process run${runs} ======================="


    if (( TO_SEE==1)) ; then
        my_exe  ${tele} &
        TO_SEE=0
    else
        my_exe  ${tele}  2>/dev/null 1>/dev/null &
    fi

    NPROC=$(($NPROC+1))

    ## to record the PID
    for((i=MAXCORE; i>0; i--))
    do
        PID[0]=$!
        if ((i>0)); then
            PID[i]=${PID[((i-1))]};
        fi
    done

    ##
    ## whenever we reach the max cores, we have to take a break.
    ## the following while loop only break whenever one process finishes.
    ##
    while (( NPROC>=MAXCORE ))
    do
        # check which process has doen.
        for((i=MAXCORE; i>0; i--))
        do
            r=$(check_PID ${PID[((i))]})
            
            if [ "$r" == "done" ]; then
                NPROC=$(($NPROC-1))
            fi
        done    
        # after checking all the PIDs, but all are running.
        # so wait a while~~
        #echo "I am in the while loop, and NPROC = $NPROC"
        sleep 1
    done
  
done


wait
echo""
echo " All runs are completed"
end_time=`date +%s`
echo " execution time was `expr $end_time - $start_time` s. "




# root -l -q Tai_script/ic_correction/_01_IC_gainMatch.C\($runs,0\)
# to get scalar data
# root -q -l ./Tai_script/get_scaler.C\(${runs}\)
