# A = x41
# B = x42
# ...
# a = x61
# b = x62
# c = x63
# ... 

echo -n -e \\x61\\x62\\x63 > myfile

# -n = do not output the trailing newline
# -e = enable interpretation of backslash escapes

od -c  myfile
# -c or -t c => select ASCII characters or backslash escapes
# we get
#0000000   a   b   c
#0000003

    # char   x_char   = 'z';  
    # short  x_short  = 2;
    # int    x_int    = 3;
    # float  x_float  = 4;
    # double x_double = 5;

    # char   y_char[2] = {'a','b'};
    # int    y_int[2]  = {1, 2};
    # float  y_float[2]= {0.5, 0.6};

od -c -N 1 data.dat 
# -N 1 = just read one bytes.
# since we first write in a char = 'z'
# 0000000   z
# 0000001

od -c -j 1 -N 2 data.dat
# -j 1 => jump one bytes
# -N 2 => read two bytes
# -t u2 => unsigned interger 2 types.


od -c -j 3 -N 4 -t u4 data.dat
# -j 3 => jump 3 bytes
# -N 4 => read 4 bytes
# -t u4 => unsigned interger 4 types.
# 0000003 003  \0  \0  \0
#                       3
# 0000007

od -c -j 7 -N 4 -t f data.dat