#!/bin/bash
# this script shows a simple usage of grep = global regular express print command.



#1 the most basic usage:
grep "xination" simple1.txt

# it will show all the substrings contain "xination"
xination
xination1234
@xination
GGGGxination





#2 start with
grep "^x" simple1.txt

# this will give you anything start from x
xination1234
xin___123






#3 end with
grep "OMG$" simple1.txt

# this will give you the substring end with OMG.
OMGxination_OMG








#4 [ ]
grep "^[xG@]" simple1.txt

# this gives you start from x or G or @
xination
xination1234
@xination
GGGGxination
xin___123






# Extended regular expression
###########################################
# for [a-z] = [:lower:]  the extended regular express(ERE)
# we use grep -E for ERE

grep -E "^[[:lower:]]" simple1.txt
xination
xination1234
xin___123







# ( ) to combine extended and basic regular expression.
# for EBE, start with xin or XIN, 
# | means or

grep -E "^(xin|XIN)" simple1.txt
xination
XINATION
xination1234
xin___123





# ? means optional 
# 1?23 = to search 123 or 23
echo 1234 | grep -E "1?23" 

1234
^^^  will be highlighted.





# {n} repeat the patten n times.
echo "1234" | grep -E  "[[:digit:]]{4}" 
# to search the digit that appear 4 times.

1234
^^^^  will be highlighted.




echo "1234" | grep -E  "[[:digit:]]{3}"

# to search the digit that appear 4 times.
1234
^^^   will be highlighted.






# to use regular expression with sed command 
# we can make substitution.
# for example to replace 1998/12/01 to 12-01-1998


echo "1998/" | sed 's:\([0-9]\{4\}\)\/: -\1 :g'
-1998
# use : as our deliminator
# s means search and substitube.
# g means glboal.
# use escape \ to apply () and {}


echo "1998/12" | sed 's:\([0-9]\{4\}\)/\([0-9]\{2\}\): \2-\1 :g'
# use () to make a subgroup, and \2 means that group.
12-1998 


echo "1998/12/01" | sed 's:\([0-9]\{4\}\)/\([0-9]\{2\}\)/\([0-9]\{2\}\):\2-\3-\1:g'

# final result.
12-01-1998


# or we can use -r for extended regular expression.
# then there is no need to use escape \ for () and {}
echo "1998/12/01" | sed -r 's:([0-9]{4})/([0-9]{2})/([0-9]{2}):\2-\3-\1:g'
12-01-1998





############################################################
# some useful tip for copy the line in txt 
#then paste it in to the command line in vim/gvim
#Step 1:  copy( yank ) the text, such as visual mode,
#Step 2: :, ctrl+r, "
############################################################

