#!/bin/bash

# here we have folder "dir", and we want to sync to "dir_backup"
# the dir and dir_backup will have the same files.
#
#  different files in dir_backup will be deleted.
# for example
#
#  dir	    |	backup/dir
#  A.txt    |	C.txt
#  B.txt    |
#
# after sync, we want:
#
#  dir	    |	backup/dir
#  A.txt    |	A.txt
#  B.txt    |   B.txt


rsync -ravz --delete --progress  source_dir backup_dir
# -r : recursive
# -a : archive, keep the original date
# -v : verbose
# -z : using compression
# --delete : delete the files that is no longer in sender side.

# note:
# rsync dir/*  backup/dir  <-- wont delete the files in destination ( backu/dir )
# this is the design of rsync
