#!/bin/bash

# Sometimes, we may encounter a situation that we need to replace
# certain lines in a file. A good way is to use function,
# and let the function parameters to control the "stuff" we want to 
# change each time.
#
# However, if we are lazy. We can use sed to do substitution,
# which works like set a variable on top of the script.


sed -i '5s|.*|newline|' demo_text.txt
# -i : to save the result at the identical input file.
# 5s : substitute line no. 5
#  | : field separator
# .* : current line
# newline : the string we want to insert

# we can also use variable to help us to do substitution.

newLine="this is the new stuff"
sed -i '6s|.*|'"$newLine"'|' _temp.C
# for using the variable, we need to add '" $var  "'
 