#!/bin/bash

# v1.txt content:
# this is version1
# same text

# v2.txt content:
# this is version2
# same text
# with some additional txt


diff v1.txt v2.txt 
# we will get
# 1c1
# < this is version1
# ---
# > this is version2
# 2a3
# > with some additional txt
# \ No newline at end of file

# the format is __src_lineX c/a/d ___des__lineY
# c = change, a = append, d = delete.


diff -c v1.txt v2.txt
# note: -c option is for the context format
# *** v1.txt	2018-06-21 16:41:47.538928236 -0400
# --- v2.txt	2018-06-22 09:14:54.962565530 -0400
# ***************
# *** 1,2 ****  <== the 1 to 2 line of v1.txt
# ! this is version1  <== ! means change
#   same text
# --- 1,3 ---- <== the 1 to 3 line of v2.txt
# ! this is version2
#   same text
# + with some additional txt <== + means addition.



diff -u v1.txt v2.txt 
# -u option is for the unified format.
# --- v1.txt	2018-06-21 16:41:47.538928236 -0400
# +++ v2.txt	2018-06-22 09:14:54.962565530 -0400
# @@ -1,2 +1,3 @@ <== the line 1 to 2 in v1.txt, the line 1 to 3 in v2.txt
# -this is version1 <== - means remove
# +this is version2 <== + means addition
#  same text
# +with some additional txt

diff -y v1.txt v2.txt
# -y option is to put two files at two sides.
# this is version1	|	this is version2         <== | means change
# same text			same text
# 			      >	with some additional txt <== > adding


# other options
# -r <== recursive ( use to compare multiple files )
# --ignore-space-change 
# --ignore-blank-line
# -a <== treat all files as text
# -N <== treat absent files as empty ones.
