#!/bin/bash

# original data
# a John
# c Sean
# d May
# f Joe
# e Lisa
# a Allen
# c Kay
# c Lou
# b Mo

sort data_sort.dat
# a Allen
# a John
# b Mo
# c Kay
# c Lou
# c Sean
# d May
# e Lisa
# f Joe


sort data_sort.dat --key 2 # <== use 2nd field to sort.
# same as -k 2

# a Allen
# f Joe
# a John
# c Kay
# e Lisa
# c Lou
# d May
# b Mo
# c Sean



sort data_sort.dat -k 2.3
# to use 2nd field as the key, but skip the first 3 chars.
# 12345
# c Kay
# d May
# c Sean
# e Lisa
# a Allen
# b Mo
# f Joe
# a John
# c Lou


#sort data_sort.dat -k 2.4
# to use 2nd field as the key, but skip the first 4 chars.
# 12345
# b Mo
# c Sean
# f Joe
# a John
# a Allen
# e Lisa
# c Lou
# c Kay
# d May


# other options:
# -r <== reverse the order
# -b <== ignore the leading blank
# -d <== dictionary order
# -f <== force to ignore the case.
