#include <iomanip>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <initializer_list>

using namespace std;

// to define our own class, which is also receive initializer_list.

class demo_class {

    private:

    vector<int> my_vector;

    public:
	// when pass a list "v", which contains int elements.
	demo_class( const initializer_list<int> &v) {

		// looping through the element in the v.
		// and use push_back() to put into our private "my_vector"
	    
		for( auto itr = v.begin(); itr != v.end(); ++ itr) {

		    my_vector.push_back( *itr);
		    // note: de-reference the pointer 
		    // to get value.
		}
	}

};


int main() {

    // C++ 11 feature.

    // initializer_list constructor
    // i.e. we can initialize a vector like the following way
    // we don't need to use push_back() ... to set the initial values.
    vector<int> v = { 1, 2, 3 };
    
    // and good news is that most of STL containers have been updated
    // to accept initializer_list
   
    // demo how to let our class to receive initializer_list
    demo_class demo_obj = { 1, 2, 3};

}

