#include <iomanip>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>

using namespace std;


int main() {

    vector<int> my_vector = { 1, 2, 3, 4, 5 };

    // in C++ 03
    // if we want to loop through a vector,
    // we have to type in like this:
    // the syntax is very long.
    for( vector<int>::iterator itr = my_vector.begin();
	    itr != my_vector.end(); ++ itr ) {
	    cout << *itr << endl; }

    cout << "==========demo 1==========" << endl;
    // in C++ 11
    // we can use auto type
    for( auto itr = my_vector.begin(); itr != my_vector.end(); ++ itr )
    { cout << *itr << endl; }

    auto a = 6;    // a is an integer
    auto b = 6.0;  // b is a  double
    auto c = a;    // c is an integer.


    // the "for each" loop in C++11 is also simplified.

    cout << "==========demo 2==========" << endl;
    for( int i: my_vector ) { cout << i << endl;   }
    // the vector<int> has begin() and end() function,
    // so  my_vector can be looped through by this way.
    // but we don't loop through it by an itr pointer,
    // we cannot modify the element in my_vector.


    cout << "==========demo 3==========" << endl;
    for( auto &i: my_vector ) {
	       i++;
	       cout << i << endl;
    }



}
