#include <iomanip>
#include <iostream>

using namespace std;

/*
 * C+11 keyword  constexpr
 * to specify a function will always return a constant expression.
 *
 * note: const keyword is to ensure we don't change the member variable
 * after execute the function.
 */


constexpr double cube ( double x ) { return x*x*x; }

constexpr int my_array_size( ) { return 3; }

int main( ) {

    int my_array_size[ my_array_size() ];  
    // in C++11, it allows us to use a function with "constexpr" to 
    // set the size of the array, and in this case, the size is 3.
    //
    // I think constexpr is a kind of substitution that complier do 
    // the calculation, and then we substitute the function with its return
    // data.


    int y = cube( 12 ); // the calculation is done at the compile time
    
}

