#include <iomanip>
#include <iostream>
#include <vector>
using namespace std;
/*
 * lambda function
 */

template<typename func>
void apply_all_elments( func f, vector<double> vec) {

    for( auto i: vec ) {

	cout << f( i ) << endl;

    }
}
// we use template to define a type "func",
// and we can pass it through lambda function.
// then we use for each loop, to loop through vec,
// and call f(i)


int main( ) {
   

    cout <<"==========demo1==========" << endl;
    
    cout << [] ( int x, int y) { return x+y; } (3,4) << endl;
    
    // [] is the key to start the lambda function.
    // this lambda function takes two parameters, ( int x, int y)
    // and we pass them by (3,4)
    // it will return x+y
    // so we will get 7.

    cout <<"==========demo2==========" << endl;

    auto f = [] (int x, int y) { return x+y; } ;
    // we can also store a lambda function to a variable.

    cout << f(5,6) << endl;
    // we will get 5+6 = 11.

    cout <<"==========demo3==========" << endl;

    vector<double> vec = { 1.0, 2.0, 3.0 };

    auto g = [] ( double a ) { return a*a; } ;

    apply_all_elments( g, vec );


    cout <<"==========demo4==========" << endl;
    // to access the local variables use [&}
    
    int a_variable = 10; 
    
    auto f2 = [&] ( int b ) 
    { 
	if ( b > a_variable ) { cout << " I am bigger " << endl; }
	else { cout << " I am smaller " << endl; }
    };

    f2(1);
    f2(100);

}

