#include <iomanip>
#include <iostream>
#include <vector>
using namespace std;


/*
   compiler generated function.

   in C++11:
   the compiler will generate functions for a class
   1. default constructor ( generated only if no constructor is declared by user)
   2. copy constructor ( generated only if no 5 and 6 declared by user )
   3. copy assignment operator ( generated only if no 5 and 6 declared by user )
   4. destructor

   5. move constructor ( generatd only if no 2, 3, 4, 6 )
   6. move assignment operator ( generated only if no 2, 3,4, 5 )
*/


// example ( Tai: a good class should have the following form )
class Dog 
{
    // C++03:
    Dog();                           // default constructor. Dog dog1():
    Dog( const Dog&  rhs);           // copy constructor. Dog dog2( dog1 ); 
    Dog& operator=(const Dog& rhs);  // copy assignment operator. dog3 = dog2;
    ~Dog();

    // C++11:
    Dog( Dog&& );             // move constructor  Dog dog4( create_dog() );
    Dog& operator=( Dog&& );  // move assignment operator. Dog dog5 = create_dog(); 
};



class Cat  // 3, 4 will be generated by compiler.
{
    Cat( const Cat& );  // copy constuctor.

    // 1 will not be generated, since we have a constructor, copy constructor.
    // 2 is here.
    // 3 will be generated by compiler.
    // 4 will be generated by compiler.
    // 5 will not be generated, since we have 2.
    // 6 will not be generated, since we have 2.
};

class Frog // 4 will be generated by compiler.
{
    Frog( int = 0 );		 // default constructor.
    Frog( const Frog&, int = 0); // copy constructor
    Frog( Frog&&, int = 0 );     // move constructor.

};


int main() {}
