#include <iostream> // for cout
#include <fstream>
using namespace std;

#include <cstdlib>
#include <cstdio> // for C style File IO

/*


*/


// in C
int main() {

	FILE* in;
	FILE* inb;
	FILE* out;
	FILE* outb;

    out = fopen ("text.txt", "w");
	/*
    |
    |    fopen(string, mode) will return a FILE* pointer.
    |    mode= r, w, a ( read, write, append),
    |         r+ for reading and writing.
    |         rb for reading binary.
	*/



    //! STEP 1: write out to File
    /*
    |   use "fprintf" to handle with string, int, float
    |   use "fputc"   to handle with char
    |
    |   fprintf(File obj ptr, "specifiers",  varibles);
    |   fputc(char, File obj ptr);
    |
    |   write out a string is some what tricky.
    */
    printf("step 1\n");
    fflush(stdout);              // sometimes printf() won't print the buffer on the screen immediately.
                                 // we can use fflush() to force it.

    fprintf(out, "%s", "PI\n");  // note the white space is not allow.



    // fun things about fprint and fflush
    fprintf(stdout, "This message will show on the screen.\n");
	fflush(stdout); // similar to the bash command $cat file
				    // it will print the content to the screen.
				    // use 'stdout'



    int    x = 10;   fprintf(out, "%d\n",  x);
    double y = 0.9;  fprintf(out, "%.3f\n",y);



    char z = 'a'; fputc(z, out);
    char str[100] = "I like physics.\n";




    //write out string, it is quite tricky...
    bool go_on = true;
    for(int i=0; i<100; i++) {
        if( str[i] == '\0' ) { go_on = false;  }
        if( go_on ) { fputc(str[i], out); }
    }

    fclose(out);








    //! STEP 2: read in from File
    /*
    |   use "fscanf" to handle with string, int, float
    |   use "fgetc"  to handle with char
    |
    |   fscanf(File obj ptr, "specifiers",  varibles);
    |   fgetc(char, File obj ptr);
    |
    |   write out a string is some what tricky.
    */
    printf("step 2\n");

    in  = fopen ("text.txt", "r");

    // checking in the reading process.
    if ( in == NULL) { cout << "Error opening file" << endl; exit(1); }

    int    x2;
    float  y2;
    char   z2;
    char str2[100] = {'\0'};


    fscanf(in,"%s",str2);  cout << "this is str2 = "<<str2 << endl;
    fscanf(in,"%d",&x2);   cout << "this is x2 = "  <<x2 << endl;
    fscanf(in,"%f",&y2);   cout << "this is y2 = "  <<y2 << endl;

    z2 = fgetc(in);   //cout << z2 << endl; // get '\n'
    z2 = fgetc(in);   cout << "this is z2 = " << z2 << endl; // get 'a'

    // reading the sting... it is quite tricky.
    for(int i=0; i<100; i++)
    {
        z2 = fgetc(in);
        if(z2 != -1 ) { str2[i] = z2; }
    }

    cout <<"this is char array = " <<str2 << endl;

    fclose(in);







    //! STEP 3: write out to File in binary format.
    /*
    |   use "fwrite" to write the binary format.
    |
    |   fwrite( address of variable, size of varible,  num of variable, FILE obj)
    |   string will still be tricky.
    */
    printf("step 3\n");

	outb = fopen ("btext.dat", "wb");
    int    x3 = 999;
    float  y3 = 1.05;
    char   z3 = 'j';


	fwrite(&x3, sizeof(x3), 1, outb);
	fwrite(&y3, sizeof(y3), 1, outb);
	fwrite(&z3, sizeof(z3), 1, outb);

    fclose(outb);




    //! STEP 4: read in from File in binary format.
    /*
    |   use "fread" to read in the binary format.
    |
    |   fread( address of variable, size of varible,  num of variable, FILE obj)
    |   string will still be tricky.
    */
    printf("step 4\n");

	inb  = fopen ("btext.dat", "rb");

    int    x4;
    float  y4;
    char   z4;


    fread(&x4, sizeof(x4), 1, inb);
    fread(&y4, sizeof(y4), 1, inb);
    fread(&z4, sizeof(z4), 1, inb);


    cout <<" this is x4 = " <<  x4 << endl;
    cout <<" this is y4 = " <<  y4 << endl;
    cout <<" this is z4 = " <<  z4 << endl;


    fclose(inb);



}



