#include <iostream>
#include <cmath> // for max
using namespace std;
/*
  the demo shows the typical C Preprocessor syntax and skill.

  http://www.tutorialspoint.com/cprogramming/c_preprocessors.htm
*/



// #define works as  string substitute
#define PI 3.1415
#define OK 1
#define test 0
#define omg "Oh my God..."

// But you can define a simple function, and we usually call it macro.
#define SQR(x)  ( (x)*(x) )

// string literal operator # and merging operator ##
#define SHOW(x) #x



int main() {

    cout << PI << endl; // show the PI

    /*once the item is defined. it will go inside */
    #ifdef OK
        cout << "Yes PI has been defined" << endl;
    #endif


    #ifdef test
        cout << "defined as zero " << endl;
    #endif


    #ifdef omg
        cout << omg << endl;
    #endif

    cout << SQR(5) << endl;

    //------------------------------------------------
    #ifdef HAHA
        cout << "we wont go inside here, since HAHA is not defined yet..." << endl;
    #endif


    // for # operator
    printf( "Here is similpe %s string\n", SHOW(3.1415) );


	//============== in the following, we show #if

    #ifndef table_size
    #define table_size 300
    #endif
    // if we have not defined table_size then set it to '300'


    // suppose someone makes table_size over than 200,
    // we undefine it first, then re define table size to '200'
    #if table_size>200
    #undef table_size
    #define table_size 200
    #endif


	cout << "table size = " << table_size << endl;

    cout << __FUNCTION__ << endl;
}



