#include <iostream>
#include <cstring>  // for strcpy()
#include <cstdio>   // for sscanf()

using namespace std;
/*
  example 1 C type: sscanf = string scan function
    http://www.tutorialspoint.com/c_standard_library/c_function_sscanf.htm

  example 2 strncmp = string comparison with n char
    int strncmp(const char *str1, const char *str2, size_t n)
    if Return value if = 0 then it indicates str1 is equal to str2
    http://www.tutorialspoint.com/c_standard_library/c_function_strncmp.htm


  Note: in C++, one can use sstream obj
  http://stackoverflow.com/questions/1033207/what-should-i-use-instead-of-sscanf
*/





int main() {


    /*-----------------example 1-------------*/
    char str[100]; // the variable to store some string.

    strcpy( str, " Saturday March 25 1989" );

    /* set the varibles to retrieve the data*/
    int day;
    int year;
    char weekday[30];
    char month[30];


    // typically when we read in a line from C style fgetc function,
    // we then can use sscanf to parse the variable inside.
    sscanf( str, "%s %s %d %d", weekday, month, &day, &year );
    /*
    | @param1 char array,
    | @param2 formater, s for string, d for integer, f for float or double
    | @param3 vars, array doesnt need &, int, float, double need &
    */

    cout << weekday << " " << month << endl;
    cout << day << " " << year << endl;

    cout << "end of example 1\n\n" << endl;




    /*-----------------example 2-------------*/

    strcpy( str, "# this is comment" );

    bool isComment;

    if ( strncmp( str, "#", 1 ) == 0 ) { isComment = true; } else { isComment = false; }
    // return 0 means they are identical.
    // we check str whether it starts with "#"


    cout << str << endl;
    if ( isComment ) { cout << "this is a comment and we can ignore it" << endl;}


    // also it is useful to skip the empty line that only has "\n", a special character

    strcpy( str, "\n" );
    cout << str << endl;
    if ( strlen(str) == 1 ) { cout << "only with '\\n', so length = 1.  it is an empty line. " << endl;}



}




