#include <iostream>
#include <stdlib.h> // for malloc, calloc, and free
using namespace std;


/*
|  In C, dynamic allocation can be implemented by malloc( or calloc) and free.
|  In C++, we use new and delete operator.
*/



int main() {

    int* array;
    array = (int* ) malloc( 10* sizeof(int) );
    /*
    | now we assign memory of 10*sizeof(int) to a pointer "array"
    | but note, malloc does not return any "type"
    | so it may be better to cast it, ie. use (int*)
    | we need to use two steps declaration, one step is not working....
    */

    /*
    | Good behavior to check whether the allocation is good.
    | when malloc fails, it will return an empty pointer.
    */
    if (NULL == array) {
	cout <<  "malloc failed\n";
	return(-1);
    }





    int* array2 = (int*) calloc(10, sizeof (int));
    /*
    | calloc() will initialize each element to zero.
    | it can be using one step declaration.
    */

    // we should see 10 zero's
    for ( int i=0; i< 10; i++) { cout << array2[i] << endl; }


    // relase memeory
    free( array);
    free( array2);

}



