#include <boost/lexical_cast.hpp>
#include <iostream>
 
using namespace std;
using boost::lexical_cast;
using boost::bad_lexical_cast; // for exception

/*
    boost library proives an universal and convenient way 
    for string cast.

    synatx 
    T1 outputVar = lexical_cast<T1> ( T2 inputVar );

*/

int main()
{
    string myString;

    // int to string
    int varINT = 345;
    myString = lexical_cast<string>( varINT );
    cout << myString.c_str() << endl;

    // double to string
    double varDouble = 2.5;
    myString = lexical_cast<string>( varDouble );
    cout << myString.c_str() << endl;

    // char to string
    char varChar = 'A';
    myString = lexical_cast<string>( varChar );
    cout << myString.c_str() << endl;


    // char array to string 
    char varCharArr[] = "xination1";
    myString = lexical_cast<string>( varCharArr );
    cout << myString.c_str() << endl;

    //=====================================================

    // string to int
    varINT = lexical_cast<int>( "123" ); 
    cout << "int = " << varINT << endl;

    // string to double
    varDouble = lexical_cast<double>( "3.1415" ); 
    cout << "doulbe = " << varDouble << endl;

    //bad case, the following demo exception handling
    try
    {
        varINT = lexical_cast<int>("56.78");
        // the input is a "double", but we cast it into int
        // boost will give us an exception.
    }
    catch( bad_lexical_cast& error )
    {
        cout << "Exception caught:" << error.what() << endl; 
        // Exception caught:bad lexical cast: source type value could not be interpreted as target

    }



    return 0;
}
