#include <fstream>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <cstdlib>
using namespace std;

/*

  in this demo, we show a trick for setting a default value for cin.
  ==> we an external file to record the default value.

  record.clear(); record.seekg(0, ios::beg);
  is to move the pointer to the beginning.

  we will ask user to input a number,
  if this number after convert from array to integer is different than
  the one in the file we read, then we write out the user input number.



*/

int main() {

    /*
    |    STEP 1: organize the existed data.
    */
    fstream record; record.open("data.dat", ios::in | ios::out);
    int  line_num = 0;
    char buff[100];

    // counting lines.
    while(1)
    {
        record.getline(buff,100);
        if ( !record.good() ) { break; }
        line_num += 1;
    }

    /*
    | When you finish reading all the contents of your file,
    | the state of the stream would be eof,
    | all subsequent input operations will fail.
    | so we have to apply clear()
    */
    record.clear();            // to reset the flag of good
    record.seekg(0, ios::beg); // then seek and read the 0 byte in the beginning (ios::beg)


    /*
    |    we need to save into buff.
    |    each line represent a data entry.
    */
    double* data = new double [line_num];
    double input_data;



    while (1) {


        // reading in the data in the external file.
        for(int i=0; i<line_num; i++) { record >> data[i]; }
        record.clear(); record.seekg(0, ios::beg);




        for(int i=0; i<line_num; i++) {

            cout <<" the current data is (" << data[i] <<"), set to: ";

            cin.getline(buff,100);


            if ( atof(buff) == 0 || atof(buff) == data[i] ) {
                // no change.

                record << data[i]  << endl; // write out to file.

            } else {

                record << atof(buff)  << endl;
            }

            cout << "\n";

        }



        char ans;

        cout << "\n Do you want do it again? (y/n): ";
        cin.getline(buff,100);

        if( strcmp(buff,"n")==0 ||  strcmp(buff,"N")==0 ) break;
        cout << "----------------------------------------" << endl;;
    }

    record.close();



}
