#include <iostream> // for cout
#include <cstring>  // for strcpy
using namespace std;

void testfunct_1( int* ptr );

int main() {


    //TOPIC: basic concept of pointer
    if( 0 )
    {

        int number = 55; // 4 bytes
        /*
            We use '&' operator to get the memory address.
        */
        cout << "  This is the memory address of number = " << &number << endl;
        //This is the memory address of number = 0xbfbd9340



        int* ptr = nullptr;
        /*
            we declare a pointr 'ptr', and it can handle int type memory.
            ie. it knows the starting memory and size of 'int'
            but now, 'ptr' is empty.
        */

        ptr = &number; // now, 'ptr' stores the starting memeber address of 'number'

        cout << "  ptr stores the address of 'number', = " << ptr << endl;
        cout << " *ptr is to de-rerfernce, and get the value of 'number', = " << *ptr << endl;
        cout << "\n\n";
        // ptr stores the address of 'number', = 0xbfbd9340
        // *ptr is to de-rerfernce, and get the value of 'number', = 55



        /*
            We can also use '&' operator to get the memory address of a pointer.

        */
        cout << " the address of the pointer itself =   " << &ptr
             << "\n different than 'number's address" <<endl;
        
        // the address of the pointer itself =   0xbfbd9344
        // different than 'number's address




        // now, we modify the de-reference pointer :
        // the 'number' will also change:
        *ptr = 100;
        cout << " after modification number = " << number  << endl;
        // after modification number = 100

    }


    //TOPIC: array and pointer
    if ( 0 )
    {
        int set[] = { 11, 22, 33 };

        /*
            array is a concept of pointer
            the 'set' stores the starting memory of an array only.
            it stores the first element's memory ( set[0] )
        */
        cout << " String memeory address = " <<  set << endl;
        cout << " de-reference value = "     << *set << endl;
        // String memeory address = 0xbf986684
        // de-reference value = 11



        /*
            for set[i], its address = ( set + i )
            its value =  set[i] or by de-reference  *(set + i)
        */

        cout << " address for set[0] = " <<  ( set + 0 ) << " , value =  "<< set[0] <<endl;
        cout << " address for set[1] = " <<  ( set + 1 ) << " , value =  "<< set[1] <<endl;
        cout << " address for set[2] = " <<  ( set + 2 ) << " , value =  "<< set[2] <<endl;
        // address for set[0] = 0xbf986684 , value =  11
        // address for set[1] = 0xbf986688 , value =  22
        // address for set[2] = 0xbf98668c , value =  33



        int* ptr = set;
        // create a pointer 'ptr' to link the first address of the array.
        // 'set' = address, so no &set.

        /*
            now 'ptr' is eqivallent to an alias of 'set' array.
            ptr[i] = *(ptr+i)
        */
        cout << " value for set[0] = " <<  ptr[0] <<endl;
        cout << " value for set[1] = " <<  ptr[1] <<endl;
        cout << " value for set[2] = " <<  ptr[2] <<endl;
        // value for set[0] = 11
        // value for set[1] = 22
        // value for set[2] = 33




        // the following is just for reference.
        // in some old code, people will use this way to loop an array.
        cout << "\n just for reference1 " << endl;
        for( int i=0; i<3; i++) {
            cout << *ptr << endl; // use de-reference to get the value.
            ptr++;                // use ++ operator to get to the next memory address.
        }
        // 11
        // 22
        // 33






        /*
            ptr = &set[0]; suppose we point to the first element
            ptr++  is equal to ptr = &set[0+i], and *ptr will diplay 22
            ptr+=2 is eqaul to ptr = &set[0+2], and *ptr will diplay 33

            ptr = &set[0];
            *ptr++ ==> will do *(ptr) first, then ptr = &set[0+1]

        */
        cout << "\n ++ operator with deference * operator " << endl;

        ptr = &set[0];
        ptr+=2;
        cout << "after ptr+=2 ==> we get " << *ptr << endl;
        // after ptr+=2 ==> we get 33

        ptr = &set[0];
        cout << "  let ptr = &set[0] "          << endl;
        cout << " *ptr   ==> we get " << *ptr   << endl;
        cout << " *ptr++ ==> we get " << *ptr++ << endl; // we will display 11 first, then ptr points to the second address.
        cout << " *ptr   ==> we get " << *ptr   << endl;
        // *ptr   ==> we get 11
        // *ptr++ ==> we get 11
        // *ptr   ==> we get 22

        cout << " note " << endl;
        ptr = &set[1];
        cout << "  let ptr = &set[1] "                  << endl;
        cout << "  *(ptr+1) ==> we get " <<   *(ptr+1)  << endl;
        cout << "  *ptr     ==> we get " <<   *ptr      << endl; //ptr still point to &set[1], unlike the ptr++ operation
        // *(ptr+1) ==> we get 33
        // *ptr     ==> we get 22

    }



    //TOPIC: pointer as function parameter
    if( 0 )
    {
        int num = 100;


        testfunct_1( &num ); // the function parameter is int* ptr,
                             // it only accept an address for int type data.
                             // so we have to use '&' opeator to get the address.


        int* set = new int [5]; // dynamical allocate memory.
        delete [] set;          // to delete it. when not use it anymore.


    }


    if( 0 ){
        // demo4
        // purpose: demo double pointer  

        char** names;

        names = new char* [2];
        
        // allocation memory
        names[0] = new char [100];
        names[1] = new char [100];

        strcpy( names[0], "xination" );
        strcpy( names[1], "Joe" );

        cout << names[0] << endl;
        cout << names[1] << endl;

    }

     if( 0 ){
        // demo5
        // purpose: demo pointer array  (similar to demo4)

        char* names[2];

        // allocation memory
        names[0] = new char [100];
        names[1] = new char [100];

        strcpy( names[0], "xination" );
        strcpy( names[1], "Joe" );

        cout << names[0] << endl;
        cout << names[1] << endl;

    }

     

}


void testfunct_1( int* ptr )
{
    // a useful application is to pass a int* x = new int [100]
    // and then we can use x[0] .. x[99]

    cout << "this is the first element = " << *ptr << endl;
}



