#include <iostream>
#include <queue>
#include <chrono>  // for high_resolution_clock
#include <vector> 
using namespace std;


/*  stact is a "first-in-first-out" designed data container.
	in:  10-> 11 -> 12
	out: 10-> 11 -> 12
 
	front() => access the front elment ( the oldest one put into the stack)
 
	pop() => remove the front element

	size() => show the size of the stack

	empty() => boolean, showing whether the stack is empty or not. 

	push( obj ) => push the object into the quence at the back position.


	fillInObjTest:
	we can push the same obj with different internal states into the queue.
	the element in the queue will have different internal states.

	fillInObjTest2: 
	push( obj_input) will create a new memory in the container,
	and the new memory links to the data of obj_input.

	so if we delete obj_input, the container still be fine,
	but we just miss the link to its original data.
 */

class simpleClass{
	private:	
		int value;
	public:
		simpleClass(){  value = 1; };
		~simpleClass(){};
		void SetValue( int input ) { value = input; }
		int  GetValue( ) { return value; }
};


template< typename T> void show_queue( T aQueue );
void fillInObjTest( ); 
void fillInObjTest2( );



int main() {
	
	queue<int> myQueue;

	myQueue.push( 10 );
	myQueue.push( 11 );
	myQueue.push( 12 );
	show_queue( myQueue );

	fillInObjTest();
	fillInObjTest2();
	return 0;
}



template< typename T> 
void show_queue( T aQueue ) {

	while( !aQueue.empty() ) {

		cout << "\t" << aQueue.front() ;

		aQueue.pop();
	}
	cout << "\n";
}
 

void fillInObjTest( ) {

	cout << "inside fillInObjTest test " << endl;

	simpleClass obj = simpleClass();

	queue<simpleClass> myQueue;

	obj.SetValue( 2 );
	myQueue.push( obj ); 

	obj.SetValue( 3 );
	myQueue.push( obj ); 
	
	cout << myQueue.front().GetValue() << endl; myQueue.pop();
	cout << myQueue.front().GetValue() << endl; myQueue.pop();
}


void fillInObjTest2( ) {
	cout << "inside fillInObjTest test 2" << endl;

	simpleClass* obj = new simpleClass();

	queue<simpleClass*> myQueue;


	myQueue.push( obj ); 

	cout << obj->GetValue()<< endl;
	// delete obj; (try to uncomment it, see its behavior)
	cout << myQueue.front()-> GetValue()<< endl;

	cout << obj << endl;
	cout << &myQueue.front() << endl;
	myQueue.pop();
}
