#include <iostream>
#include <string>
using namespace std;
void demo_find_substring( );
void demo_using_formater( );
/*

    http://www.cplusplus.com/reference/string/string/


    Strings are arrays of chars.
    String literals are words surrounded by double quotation marks.

    C-style strings terminate with '\0'.

    useful methods:
    size()      return the size of a string.
    length()    return the actual number of chars 
    c_str()     return the C-style string which has '\0' in the end.
   
    find("xyz") return the position of "xyz" substring.

    compare( startIdx, length, "string" ) return true of false.
    ex. aString.compare( 0, 1, "#" )  see the first line starts with "#".

    string substr (size_t pos = 0, size_t len = npos) const;
    return a substring from "pos" index with len chars,
    by default, len = npos ( until the end of the string )

*/

int main() {


    // basic

    string s = "Hello world";

    cout << s << endl;

    cout << "this sentence is " << s.size() << " long. " << endl;


    // the '+' operator is overloaped to concantenate.
    cout << s + " + extra string" << endl;


    cout << "\n________________________\n";

    // at()
    for(int i=0; i < s.size() ;i++) { cout << s.at(i) <<"\n"; }



    cout << "\n________________________\n";


    // transform to the C-style string which has '\0' in the end
    // we need to use c_str() method.

    const char* s_ctype = s.c_str();

    for(int i=0; i < s.size() + 1 ;i++) { 
		cout << s_ctype[i] << " " 
			 << static_cast<short>( s_ctype[i] )<<"\n"; 
	}


    cout << "\n________________________\n";

    demo_find_substring();


    cout << "\n________________________\n";

	demo_using_formater();
}


void demo_find_substring ( ) {


    string str = "This_is_a_test_string.txt";

    string str2 = str.substr (0,4);     // "this", 0 = starting pos, 4 = length
                                        //  if we don't have set the length, for example (6)
                                        //  it will take from [6:end]

    cout << "\n\n substring test: " << endl;
    cout << str << "\n" << str2 << endl;



    // how to get the suffix:
    cout << "\n\n find suffix test: " << endl;
    std::size_t pos = str.find(".");      // find() method's return is 'size_t'
                                          // it will return the position.

    cout << "position of '.' is at " << pos << endl;


    string str3 = str.substr( pos ); //
    cout << str3 << "\n";



}

void demo_using_formater( ) {
	// we can use sprintf() to create a string (stored in char array)
	// then assign to std::string.
	char buff[500];

	sprintf(buff, "this is number = %8.3f", 3.1415 );
	// result:this is number =    3.142

	std::string outString = buff;

	std::cout << outString << std::endl;

}
