#include <iostream>
#include <vector>
#include <deque>
#include <list>
#include <set> // with set and multiset class
#include <map> // with map and multimap class
#include <unordered_set> // with unordered_set/multiset
#include <unordered_map> // with unordered_map/multimap
#include <algorithm> 
#include <numeric>      // some numeric algorithm
#include <functional>   // functor.

using namespace std; // STL library is in the std namespace.

/*
    
     
    //=================================================================


*/



int main() {

    // (1) random access iterator
    // for vector, deque, array
    vector<int> vec = { 0, 1, 2, 3, 4, 5}; 
    vector<int>::iterator itr = vec.begin(); 
    // now vec points to the first elment in the vector.
   
    itr = itr +  2; // move 2 step forward.
    // cout << *itr << endl; // it will print 2.

    itr = itr -  1; // move 1 step backward.
    // cout << *itr << endl; // it will print 1.

    // we can do ++ and --
    ++itr; 
    // fast than post increment itr++,
    // since pre increment doesn't need to store the previous value.
    --itr;

    // we can also compare the iterator.
    auto itr1 = vec.begin();
    auto itr2 = itr1 + 1;
    if( itr2 > itr1 ) cout << "itr2 > itr1 " << endl;


    //(2) bidirectional iterator
    // for list, set/multiset/, map, mulltimap ( they are always sorted )
    // no itr + 5 ( cannot add value to iterator)
    // no itr1 > itr2 ( cannot compare iterator ) 
    // we only have: ++ and --
    // forward_list only has ++
 
    set<int> mySet = { 0, 1 , 2, 3 ,4 };
    set<int>::iterator itr_set = mySet.begin();
    itr_set++;
    cout << *itr_set << endl; // will print out 1


    //(3) unorder containers.
    // their iterators  only have ++.





    //===================================================================
    // every container has a iterator and const_iterator class
    // const_iterator provides only READ access.

    vector<int>::const_iterator itr_const = vec.begin();
    // *itr_const = 100; will be cause an error.

    // in c++11, we can use cbegin() and cend()
    // it is similar to begin() and end(), 
    // but it return const_iterator obj.

    // advance() function.
    // work for all iterators ( list, set, unordered_set, etc ... )
    itr = vec.begin();
    advance( itr, 2 );    // move 2 steps forward.
    cout << *itr << endl; // it will print 2.
  
    // distance() function
    // also work for non-random-access iterator.
    itr1 = vec.begin();
    itr2 = itr1 + 3; 
    cout << distance( itr1, itr2) << endl; // it will print 3.



    //======================================================================
    // predefined iterator ( iterator adaptor )
}
