#include <iostream>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <vector>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <string>
#include "demo_class.h"
#include "X.h"
#include "Y.h"
#include "feet.h"
#include "Array.h"
using namespace std;


int main()
{






    //---------------------------------------------------------------------
    //          object conversion
    // in the UK_distance class, we have operator float() { ... }
    // this function is invoked when we assign the UK_distance object
    // to a float variable.
    // ie. f= obj
    // it means f = obj.float()
    //---------------------------------------------------------------------

    if( 0 ){

        UK_distance obj(5,6); // 5 feet 6 inches.

        float f;

        f = obj;    // this will invoke operator float()
        printf(" f = %.1f inches\n", f ); // get 5.5


    }



    //---------------------------------------------------------------------
    //          overloading operator >
    //  in UK_distance, we have:
    //  bool operator> (const UK_distance &obj);
    //
    //  it will be invoked when we have: objA > objB
    //  it is equal to objA.operator_>( objB), and the return value is bool.
    //  obj2 will be the argument, and now operator > becomes a function key
    //  word.
    //---------------------------------------------------------------------

    if( 0 ) {

        UK_distance objA(5,10), objB(5,3);

        if (objA > objB)
        {
            cout << "The setup is ok"<<endl;

        } // this if statement will be true.
    }


    //---------------------------------------------------------------------
    //          overloading operator ++
    //  in UK_distance, we have:
    //  UK_distance operator++();     for ++obj, we add first and then run.
    //  UK_distance operator++(int ); for obj++, we run first and then add.
    //---------------------------------------------------------------------

    if( 0 ) {

        UK_distance    dis_obj(5,11);

        printf("before %d feet and %d inch \n",  dis_obj.getFeet(), dis_obj.getInch() );
        // 5, 11

        dis_obj++;

        printf("after  %d feet and %d inch \n",  dis_obj.getFeet(), dis_obj.getInch() );
        // 6, 0
    }



    //---------------------------------------------------------------------
    //          copy constructor
    //  in PersonInfo class, we have:
    //  PersonInfo::PersonInfo( const PersonInfo &obj )
    //  this is generally called copy constructor.
    //  note in c++11, we have move constructor to avoid costly copy.
    //---------------------------------------------------------------------

    if( 0 ) {

        PersonInfo Jim( "Jim Young" );
        // call PersonInfo::PersonInfo(char* n) constructor

        PersonInfo copyTest( Jim );
        // PersonInfo::PersonInfo( const PersonInfo &obj )

        cout << copyTest.getName()<<endl; // ps. display the result
        // we get "Jim Young"
    }

    //---------------------------------------------------------------------
    //          overloading operator =
    //  in PersonInfo, we have:
    //  PersonInfo operator=( const PersonInfo &obj )
    //---------------------------------------------------------------------

    if( 1 ) {

        PersonInfo Jim( "Jim Young" );
        // call PersonInfo::PersonInfo(char* n) constructor

        PersonInfo copyTest = Jim;
        // call PersonInfo::PersonInfo(const PersonInfo &obj) copy constructor.

        cout << copyTest.getName()<<endl;
        // we get "Jim Young"




        copyTest = "Bob Faraday";
        // call void PersonInfo::operator=( const char* name_input )

        cout << copyTest.getName()<<endl;
        // we get Bob Faraday.
    }





    //-------------------------------------------------------------------
    //          Copy constructor
    //---------------------------------------------------------------------
    /*

    PersonInfo person1("Michael");

    PersonInfo person2 = person1;

    cout << person1.getName()<<endl;
    cout << person2.getName()<<endl;
    */



    //---------------------------------------------------------------------------------------
    //          Memberwise Assignment
    //---------------------------------------------------------------------------------------
    /*
    Rectangle_CLASS box1;

    box1.setLength(10);
    box1.setWidth(20);

    Rectangle_CLASS box2 = box1;  // initialization of box2
                                  // the value is set to equal to box1.

    cout << box2.getLength() << " " << box2.getWidth()<<endl;
    */


    //---------------------------------------------------------------------------------------
    //          static member function
    //---------------------------------------------------------------------------------------
    /*
    demo_class::testfunction(5);  // call a static function before any instance of a class.

    demo_class obj1;

    obj1.testfunction(10); // call a static function after the instance of a class.
    */



}

