
using namespace std;

template<typename T>
class Matrix{

private:
  unsigned short m_rows;
  unsigned short m_cols;
  vector<T> m_data;
  
public:

  // constructor
  Matrix( unsigned short rows, unsigned short cols):
    m_rows( rows ),
    m_cols( cols ),
    m_data( rows*cols, 0 ) // vector<T>::vector<T>( # of element, init value) 
  {

  } // end of constructor.

  // destructor
  ~Matrix() { } 
  
  /*! @brief overload operator ()
   *  so, we can do obj(x,y) to access a matrix element.
   *  
   *  @return a reference to the value of a matrix element.  
   *  in this way, we can do obj(x,y) = 5
   */
  T& operator() ( unsigned short row, unsigned short col) {
      return m_data.at( m_cols* row + col );
  }

  void print() {
    
    int counter = 0;

    for( auto itr = m_data.begin(); itr != m_data.end(); itr++ ) 
    {
      cout << *itr << " ";
      counter+= 1;
      if( counter % m_cols == 0 ){ cout << "\n"; }
      else{ cout << ","; }
    }	
  }

  unsigned short rows(){  return m_rows;  };

  unsigned short cols(){  return m_cols;  };

  Matrix<T>& operator+ ( Matrix<T> & m_input ) {

    Matrix<T> *temp = new Matrix<T>( m_rows, m_cols);
    // we cannot return a local object, 
    // and hence we need to dynamic allocate an object.
    // since I still want to keep "this" and  "m_input" unchanged.
    for( int i=0; i<m_rows; i++){
    for( int j=0; j<m_cols; j++){

	(*temp)(i,j) = (*this)(i,j) + m_input(i,j);

      }}
    return *temp;
  }
};





void testMatrix() {

  Matrix<float>* obj = new Matrix<float>(2,3);

  cout << "this is row number =" <<  obj->rows() << endl;
  cout << "this is col number =" <<  obj->cols() << endl;

  (*obj)(0,0) = 6;

  float x = (*obj)( 0, 0 ); 

  cout << "this is x = " <<  x << endl;

  obj->print();

  cout << "test2" << endl; 
  Matrix<float>* obj1 = new Matrix<float>(3,3);
  Matrix<float>* obj2 = new Matrix<float>(3,3);
  Matrix<float>* obj3 = new Matrix<float>(3,3);

  (*obj1)(0,0) = 1;
  (*obj2)(0,1) = 2;
  (*obj3) = *obj1 + *obj2; 
  //==================== 
  cout << "obj1: " << endl;
  obj1->print();
  
  cout << "obj2: " << endl;
  obj2->print();
  
  
  cout << "obj3: " << endl;
  obj3->print();
}
