#include <iostream>
using namespace std;

/*
    summary:
    It is possible to specify template parameter.
    <typename T, int N > ==> <T,5>
    the firs para is from input type, and second has to be an int.

    <typename T=char, int N=10 >,
    both parameter is set initially, and so 
    we can use <> non-type to create object.

***************************************/



// class template
// T = type from input, N is set to int type already  
template <typename T, int N>
class mysequence {
    T data [N];
  public:
    void setmember (int x, T value);
    T getmember (int x);
};

// member funcitons from mysequence ========================
template <typename T, int N>
void mysequence<T,N>::setmember (int x, T value) 
{ data[x]=value; }



template <typename T, int N> T mysequence<T,N>::getmember (int x) 
{ return data[x]; }
//=========================================================



//  class template, we type T has the default type = char
//  however, "T" type is not used. 
template <typename T=char, int N=200>
class customerName {
    string data;  
public:
    customerName( const char* name ) {
        data = name;
    }
    string inline getName(){ return data.c_str(); }
};



int main(){


    // demo1 
    cout << "\ndemo1:" << endl;
    mysequence <int,5>    myints;    // contain an   int array of 5 elements
    mysequence <double,5> myfloats;  // contain a double array of 5 elements

    myints.setmember (0,100);
    myfloats.setmember (0,3.1416);
    cout << myints.getmember(0) << '\n';
    cout << myfloats.getmember(0) << '\n';
    // we get output:
    // 100
    // 3.1416

    // demo2
    cout << "\ndemo2:" << endl;
    customerName<> employee1("xination");
    cout << employee1.getName() << endl;
    // we get output: xination

    customerName<char> employee2("John");
    cout << employee2.getName() << endl;
    // we get output: John

    
    return 0;
}
