#include <iostream>
using namespace std;

/*
    summary:
    // part1: general part
    template <typename T>
    class myContainer { .... }

    // part2: specialized part
    Template <> 
    class myContainer <char> { .... }

***************************************/



// the class template contains two parts
// part1: general part
template <typename T>
class myContainer {
  private:
    T element;
  public:
    myContainer (T arg) {element=arg;}
    T increase () {return ++element;}
};

//===================================================
// part2: specialized part (only for <char>)
template <> 
class myContainer <char> {
  private:
    char element;
  public:
    myContainer ( char arg ) { element=arg; }
    
    char uppercase ();  
};

// Dont add template<>
char myContainer<char>::uppercase(){
  
  if( (element>='a') && (element<='z') ) {
        element += 'A'-'a';    
        // note: 'A' char = 65, and  'a' char = 97
    }
    return element;
}
//===================================================

int main(){


    // demo1 
    cout << "\ndemo1:" << endl;
    int x = 7;
    char y = 'j';
    printf("before x = %d, y=%c\n", x, y );
    myContainer<int> myint (7);
    myContainer<char> mychar ('j');

    x = myint.increase();
    y = mychar.uppercase();
    printf("after  x = %d, y=%c\n", x, y );

    return 0;
}