/*
	a friend of a class is defined outside the class's scope,
	but the "friend" can access all the private and protected 
	members. 

 */

#include <iostream> 

class DummyClass {
private:

	int fPrivateVariable;

public:
	DummyClass() {}

	void set_private_variable(int input ) { fPrivateVariable = input;}

	// when you see "friend", it means this function
	// is not defined in this class, and normally,
	// you will see argument is the class's reference.
	friend void print_private_variable( DummyClass & obj );

};

//===================================================================

// note: print_private_variable is outside DummyClass:: scope.
// but since declare "print_private_variable()" is a friend to
// DummyClass, and so it can access the "fPrivateVariable"
void print_private_variable( DummyClass & obj) {

	std::cout << obj.fPrivateVariable << std::endl;

}

int main( ) {

	DummyClass x;
	x.set_private_variable( 10 );
	print_private_variable( x );


}
