/*
 	1. in your GeneralClass class add the following line:
 	friend class UnitTest;

	2. in the UnitTest, create method takes 
	GeneralClass's reference.

	
	ref: http://www.cplusplus.com/doc/tutorial/inheritance/

=======================================================================*/

#include <iostream> 
using std::cout;
using std::endl;

class UnitTest;

class GeneralClass {
  
  friend class UnitTest; // <=== key 
  
  private:
    int fvar_private;
  	int getSquare( ){ return fvar_private*fvar_private; }

  public:
    GeneralClass () {};
    void setValue( int input ){ fvar_private = input; };
};

//===========================================
class UnitTest {
	GeneralClass fObj;    
  public:
     
    void checkPrivateValue( GeneralClass & obj)
    {
		cout << obj.fvar_private << endl;    	
    }

     void checkPrivateMethod( GeneralClass & obj)
    {
		cout << obj.getSquare() << endl;    	
    }

    // alternatively, we can use a private member (fObj)
    void checkPrivateMethod2()
    {
		fObj.setValue( 25 );    	
		cout << fObj.getSquare() << endl;
    }
};



 

int main( ) {

	GeneralClass xx;
	xx.setValue( 10 );

	UnitTest t;
	t.checkPrivateValue(  xx ); // should print out 10.
	t.checkPrivateMethod( xx ); // should print out 100.
	t.checkPrivateMethod2( );   // should print out 25 * 25 = 625
}
