#include <iostream> // for cout
using namespace std;

/*  return rules:

	myClass  func1( ){ return static_obj;  } // return a copy
	myClass& func2( ){ return static_obj;  } // return address

	for return myClass&
	we still need to use a reference to receive it, otherwise,
	it will again be treated as an new copy.
	myClass& obj = func2()

	to use pointer to receive myClass& is possible:
	myClass* ptr = & func2(); <== add "&" to do address.
	
*/


class myClass{
public:
    int     var;

	// constructor
    myClass(): var(1){}
};

static myClass static_obj;


myClass  func1( ){ return static_obj;  } // return a copy
myClass& func2( ){ return static_obj;  } // return address




int main() {

	myClass testObj1 = func1();

	testObj1.var = 10;

	cout << testObj1.var << " and " << static_obj.var << endl;
	// we get 10 and 1



	//=========================================================
	myClass testObj2 = func2(); 

	testObj2.var = 10;

	cout << testObj2.var << " and " << static_obj.var << endl;
	// we get 10 and 1
	// testObj2 is a copy, it cannot affect static_obj.


	//=========================================================
	myClass& testObj3 = func2(); 

	testObj3.var = 10;

	cout << testObj3.var << " and " << static_obj.var << endl;
	// we get 10 and 10
	// testObj3 links to static_obj, it can affect static_obj.
	static_obj.var = 1; // reset 
	
	
	//=========================================================
	myClass* aPtr = & func2()  ; 

	aPtr->var = 20;

	cout << aPtr->var << " and " << static_obj.var << endl;
	// we get 20 and 20
	// aPtr is set to the address of static_obj, it can affect static_obj.
	static_obj.var = 1; // reset 
	
	return 0;
}

