#include <iostream> // for cout
using namespace std;

class myClass{
public:
    int     fVaraible1;
    float   fVaraible2;

    myClass():
    fVaraible1(1),
    fVaraible2(2.0) {}


};


void func1( int &x  ){

    x = x + 1;

}



void func2( myClass &obj  ){

    obj.fVaraible2 += 10.0;

}


int main() {



/*---------------------------------------------------

    pass a value into a function will take costly
    performance, since the function has to copy the
    value.

    Instead, we can pass the "address" of a variable,
    then just work the address. In this way, we call
    "passing by refernce". Also, we can modify the
    input variable by passing by reference, which is
    not possible for passing by value.

    If we pass by value instead of reference, a function
    just deal with the copies of its input arguments.
    
---------------------------------------------------*/

    // ===== example1 =====
    int myValue = 1;

    func1( myValue ); // now myValue = 2
    // passing my reference
    // note: we don't need to put a "&" when invoking the function.,
    // compiler knows to pass by reference.

    printf("myValue = %d \n", myValue ); // get 2


    //===== example 2=====

    myClass  myObj; // fVaraible2 = 2.0

    func2( myObj ); // now fVaraible2 = 2.0 + 10.0

    printf("fVaraible2 = %.1f \n", myObj.fVaraible2 ); // get 12


    //===== example 3 =====

    myClass*  myObj2 = new myClass();

    func2( *myObj2 );
    // since we take in an object's reference.
    // we have to de-reference a pointer.

    printf("fVaraible2 = %.1f \n", myObj2->fVaraible2 ); // get 12


}

