#include <thread>
#include <iostream>
#include <string>
using namespace std;

/*
    std::thread's constuctor takes in a function or a functor class,
    then ... ( i.e. its argument)
    
    when passing by reference, we need to do std::ref( xxx ) as thread's
    arguments.
*/

// using a functor class as our wrapper class.
class Fctor {

  public:
    void operator() ( std::string & msg ){
        msg += "... xination";
        cout << "it says " << msg << "." << endl;
    }

};

class Fctor_Add {

  public:
    void operator() ( int & sum, int value ){
         sum += value;
    }
};

int main() {

    
    string aString = "hello -- from t1";
     

    // this one work, but we need a obj from Fctor.
    //   Fctor fct;
    //   thread t1( fct, aString ); 

    thread t1( ( Fctor() ), std::ref(aString) ); 
    // note the an extra () for ( Fctor() )
    // if we want to pass by the reference,
    // we have to use std::ref( xxx )
    // by default, thread always copies values. 
    // now, the child thread can change the data in aString.

    // we can also consdier std::move(xxx) 

    t1.join();


    int sum = 0;
    thread t_1( ( Fctor_Add() ), std::ref(sum), 1 );  
    thread t_2( ( Fctor_Add() ), std::ref(sum), 2 );  
    thread t_3( ( Fctor_Add() ), std::ref(sum), 3 );  
    thread t_4( ( Fctor_Add() ), std::ref(sum), 4 );  

    t_1.join(); t_2.join(); t_3.join(); t_4.join();
    cout << "sum = " << sum << endl;

    return 0;
}