#include <thread>
#include <iostream>
#include <string>
#include <fstream>
#include <mutex>  // for mutual exclusion.
using namespace std;


/*  this is same example as 03_mutual_exclusion.cpp
    but we don't use cout, but use fstream,
    the printing will be store in log.txt
*/

class LogFile{
  private:
    // now mutex object is a varaible inside LogFile class.
    // so as the fstream object 'f'
    // so remember, we should not let outside to access them.
    std::mutex m_mutex; 
    fstream f;
  public:
    LogFile() {
        f.open("log.txt", ios::out ); f.close();
        f.open("log.txt", ios::out );
    } 
    ~LogFile() { f.close(); }

    void shared_print( string msg, int iValue) {

        std::lock_guard< std::mutex>  guard( m_mutex );

        f << msg <<" " << iValue << endl;
    }
};
 
void Printing_job( LogFile& log ){
    
    for( int i=0; i>-20; i--) {
        log.shared_print( string("Hello, I am from t1 thread: "), i );    
    }
    
}

int main() {

    LogFile log;

    thread t1( Printing_job, std::ref(log) );

     for( int i=0; i<20; i++) {
        log.shared_print( string("Hey, I am from main thread: "), i );    
    }
    
 
    t1.join();

    cout << "see log.txt" << endl;

    return 0;
}