#!/bin/bash

single_cpp_source=$1

 
if [ "$1" = "" ]; then
    echo "Don't forget to input a source file, the output is demo"
    exit 1
fi

if [ -e "demo" ]; then
    rm demo
fi

if [ -e "file.all" ]; then
    rm file.all
fi

if [ -e "file.opt" ]; then
    rm file.opt
fi
 
g++-7 -std=c++1z -O3  -ftree-vectorizer-verbose=1 \
                      -o demo \
                      ${single_cpp_source} 

# for g++ (4.8) use -march=core-avx2
# for g++-7  use -march=skylake

 -ftree-vectorizer-verbose=n
           This option is deprecated and is implemented in terms of -fopt-info. Please use -fopt-info-kind form instead, where kind is one of the valid opt-info
           options. It prints additional optimization information.  For n=0 no diagnostic information is reported.  If n=1 the vectorizer reports each loop that got
           vectorized, and the total number of loops that got vectorized.  If n=2 the vectorizer reports locations which could not be vectorized and the reasons for
           those. For any higher verbosity levels all the analysis and transformation information from the vectorizer is reported.

           Note that the information output by -ftree-vectorizer-verbose option is sent to stderr. If the equivalent form -fopt-info-options=filename is used then the
           output is sent into filename instead.


# g++-7 -std=c++1z -g -O3  -funroll-loops -ftree-vectorizer-verbose=1 \
#                          -fopt-info-loop-optimized=file.opt \
#                          ${single_cpp_source} -o demo 

# g++-7 -std=c++1z -g -O3  -floop-parallelize-all -ftree-parallelize-loops=4 \
#                          -fopt-info-all=file.all \
#                          ${single_cpp_source} -o demo

# -fopt-info-all=file.all \
# -fopt-info-loop-optimized=file.opt \
# -fopt-info-vec-missed=file.miss \

if [ -e "demo" ]; then
    echo "result:  " 
    ./demo
fi
