/// \file B1DetectorConstruction.hh
/// \brief Definition of the B1DetectorConstruction class

#ifndef B1DetectorConstruction_h
#define B1DetectorConstruction_h 1

#include "G4VUserDetectorConstruction.hh"
#include "globals.hh"

class G4VPhysicalVolume;
class G4LogicalVolume;

/// @brief Detector construction class to define materials and geometry.  
/// + Construct(): set up the geometry and assign the scoring volume.  
/// + GetScoringVolume(): return the scoring volume.  
class B1DetectorConstruction : public G4VUserDetectorConstruction
{
  public:
    
    B1DetectorConstruction();

    virtual ~B1DetectorConstruction();

    virtual G4VPhysicalVolume* Construct();

    G4LogicalVolume* GetScoringVolume() const { return fScoringVolume; }

  protected:
    G4LogicalVolume*  fScoringVolume;
     
};



#endif

