import ROOT
import math


if __name__ == '__main__':
    
    histo2d = ROOT.TH2D( "histo2d", "histo2d", 100, -10,10, 100, -10, 10 )

    theta = 30. * math.pi / 180.
    
    for ii in range( 100000 ):
        x = ROOT.gRandom.Gaus(0,1)
        y = ROOT.gRandom.Gaus(0,2)
        xNew = math.cos( theta ) * x - math.sin( theta ) * y 
        yNew = math.sin( theta ) * x + math.cos( theta ) * y
        # histo2d.Fill( x, y )
        histo2d.Fill( xNew, yNew )

    canvas1 = ROOT.TCanvas("canvas1")
    canvas1.Divide( 1,2 )
    projX = histo2d.ProjectionX()
    projY = histo2d.ProjectionY()
    canvas1.cd( 1 ); projX.Draw()
    canvas1.cd( 2 ); projY.Draw()

    canvas2 = ROOT.TCanvas("canvas2")
    histo2d.Draw("col")