import numpy  as np
from numpy import linalg as LA
 
import math
np.set_printoptions(precision=2)

theta = 150. * math.pi / 180.

U = np.array( [[ math.cos(theta), math.sin(theta)], \
               [-math.sin(theta), math.cos(theta)]]    )

print "matrix U = \n", U 
# [[ 0.87  0.5 ]
#  [-0.5   0.87]]


Lambda = np.array( [[ 1, 0], \
                    [ 0, 2]]  )

U_inv = LA.inv( U )
U_tra = U.transpose()

# check U_transpose = U_inverse 
if( 0 ):
    print U_tra;
    print U_inv



# S = U . Lambda . U_transpose
S = np.dot( U, np.dot( Lambda, U_inv )  )
eigenvalues, eigenvectors = LA.eig( S )
 
# print out individual eigenvectors
if( 1 ):
    print "matrix S = \n", S
    for i in range( len(eigenvalues) ):
        print "%dth eigenvalues = %.3f" %(i+1, eigenvalues[i])
        print eigenvectors[i]
        print ""



print "__________________________________________________"
_L_ =  np.array( [[ eigenvalues[0], 0], \
                  [ 0, eigenvalues[1]]]  )

_M_ =  np.row_stack( [ eigenvectors[0], eigenvectors[1] ]  ) 
_M_inv =  LA.inv(_M_)
# note the return for eigenvectors are actually row not col!!!!

M1 = np.row_stack( [ eigenvectors[0], eigenvectors[1] ]  )
M2 = np.row_stack( [ eigenvectors[1], eigenvectors[0] ]  )



# print "eigenvalue matrix = \n", _L_ 
# print "eigenvector matrix = \n", _M_ 

# print "__________________________________________________" 
# print np.abs( S - np.dot( _M_, np.dot( _L_, _M_inv ))  < 1e-5) 
# should be = S

# print np.dot( LA.inv(_M_), np.dot( S, _M_ )  )   # should be = Lambda