#include <iostream>
#include <vector>
#include <boost/math/quadrature/gauss.hpp> 

// https://www.boost.org/doc/libs/1_66_0/libs/math/doc/html/math_toolkit/gauss.html
using namespace std;
using namespace boost::math::quadrature;

int main()
{
    auto f = [](const double& x) { return  std::exp( -x*x ); };

    // Internally class gauss has pre-computed tables of abscissa and weights
    // for 7, 15, 20, 25 and 30 points at up to 100-decimal digit precision.

    double quadrature;
    
    constexpr int n  = 1;
    quadrature = gauss<double, n  >::integrate(f, -3, 3);    
    printf("n=%d integral = %.10e\n", n, quadrature  );

   
    quadrature = gauss<double, 2  >::integrate(f, -3, 3);    
    printf("n=%d integral = %.10e\n", 2, quadrature  );
   
    // quadrature = gauss<double, 3  >::integrate(f, -3, 3);    
    // printf("n=%d integral = %.10e\n", 3, quadrature  );
   
    // quadrature = gauss<double, 4  >::integrate(f, -3, 3);    
    // printf("n=%d integral = %.10e\n", 4, quadrature  );

    // quadrature = gauss<double, 5  >::integrate(f, -3, 3);    
    // printf("n=%d integral = %.10e\n", 5, quadrature  );
   
    quadrature = gauss<double, 7  >::integrate(f, -3, 3);    
    printf("n=%d integral = %.10e\n", 7, quadrature  );

    quadrature = gauss<double, 30  >::integrate(f, -3, 3);    
    printf("n=%d integral = %.10e\n", 7, quadrature  );

    return 0;
}




