import scipy
from scipy import integrate
import numpy as np
import math

# https://docs.scipy.org/doc/scipy-0.14.0/reference/generated/scipy.integrate.quadrature.html

def f2( x, *args ):
    a = args[0]
    c = args[1]
    s = args[2]
    return a * np.exp( ( (x-c)/s )**2 )

def f1( x ):
    
    return np.sin(x)

if __name__ == '__main__':
	
    results = []
    for n in range( 1, 10):
        result,err = scipy.integrate.quadrature( f1, 0, math.pi, maxiter=n )
        
        # result,err = scipy.integrate.quadrature( f2, -3, 3, args=(1,0,1), maxiter=n  ) # 3-sigma
        # result,err = scipy.integrate.quad( f2, -3, 3, args=(1,0,1)  ) # 3-sigma
        results.append( result)

    for n in range( len(results) ):
        print "n=%d integral = %.10e ,err =%.3e " %(n, results[n], 2- results[n]  )

    
    
 
