#include <cmath>
//========================================= for random generator between [0,1]
static unsigned long jz;
static unsigned long jsr=123456789; // seed
#define SHR3 (jz=jsr, jsr^=(jsr<<13), jsr^=(jsr>>17), jsr^=(jsr<<5),jz+jsr)
#define UNI (.5 + (signed) SHR3*.2328306e-9) 
//=============================================================================

void testSpeed();

void testFill();

void Box_Muller() {

    testSpeed();
    testFill();

}


void testFill(){
    
    TH1D* h1 = new TH1D( "h1", "h1", 1000, -5, 5 );
    const double PI = TMath::Pi();
    for( int ix = 0; ix<1000000; ix++ ){

        double u1 = UNI;
        double u2 = UNI;
        double z1 = sqrt( - 2 * log(u1) ) * cos( 2* PI * u2 );
        h1->Fill( z1 );
    }
 
    h1->SetLineWidth( 2 );
    h1->SetLineColor( kBlack );
    h1->Draw();
}

void testSpeed(){

    const double PI = TMath::Pi();
    auto start = std::chrono::high_resolution_clock::now();
    for( int ix = 0; ix<1000000; ix++ ){

        double u1 = UNI;
        double u2 = UNI;
        double z1 = sqrt( - 2 * log(u1) ) * cos( 2* PI * u2 );
    }
    auto finish = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> elapsed = finish - start;
    printf("Elapsed time: %.5f ms (%s)\n", elapsed.count()*1000, "Box Muller trans." );


}

 
