import numpy as np
from numpy.random import uniform
import ROOT
import math
import time

# https://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform
# Box-Muller transform
if __name__ == '__main__':


    h1 = ROOT.TH1F("h1","histo", 1000, -11., 11 )
    center =1 ; sigma = 2.5 ;
    startTime = time.time()
    for ix in range( 1000000):
        u1 = uniform(0,1)
        u2 = uniform(0,1)

        z1 = math.sqrt( - 2 * math.log(u1) ) * math.cos( 2* math.pi * u2 )
        # z2 = math.sqrt( - 2 * math.log(u1) ) * math.sin( 2* math.pi * u2 )

        x = center + z1*sigma
        h1.Fill( x )
    endTime = time.time()
    print "exec time = ", (endTime - startTime), "seconds"

    canvas1 = ROOT.TCanvas("canvas1")
    h1.Draw()
