#include <fstream>
static double yy[2000] ;
static double inverseCDF[2000] ;

//========================================= for random generator between [0,1]
static unsigned long jz;
static unsigned long jsr=123456789; // seed
#define SHR3 (jz=jsr, jsr^=(jsr<<13), jsr^=(jsr>>17), jsr^=(jsr<<5),jz+jsr)
#define UNI (.5 + (signed) SHR3*.2328306e-9) 

//=============================================================================



void assign_value() {

	fstream fIn;

	fIn.open( "coeff.dat", ios::in );

	char buffer [200];

	fIn.getline( buffer, 200 );

	double y, value;
	
	int ipt = 0;

	while( 1 ) {
	
		fIn >> y >> value; 
		if( !fIn.good() ) break;

		
		yy[ ipt ] = y;
		inverseCDF[ ipt ] = value; 
		ipt += 1; 

	}

	fIn.close();
}


double sampling( double yr ) {
	
	
	int idx = int(  ( yr - yy[0]) / ( yy[1]-yy[0]) );
	
	double yy1 = yy[ idx ];
	double yy2 = yy[ idx + 1 ];

	double value1 = inverseCDF[ idx ];
	double value2 = inverseCDF[ idx + 1  ];

	return value1 + ( value2 - value1 )/ ( yy2 - yy1 ) * ( yr - yy1 );

}


void testSpeed(){
    
    auto start = std::chrono::high_resolution_clock::now();
    for( int ix = 0; ix<1000000; ix++ ){

        
        double yr = yy[0] + ( yy[1999] - yy[0]) * UNI;
        double value = sampling(yr);
    }
    auto finish = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> elapsed = finish - start;
    printf("Elapsed time: %.5f ms (%s)\n", elapsed.count()*1000, "inverseCDF" );
}


void testFill() {

	TH1D* h1 = new TH1D( "h1", "h1", 1000, -5, 5 );
 
    for( int ix = 0; ix<1000000; ix++ ){

    	double yr = yy[0] + ( yy[1999] - yy[0]) * UNI;
        h1->Fill( sampling(yr) );
    }
 
    h1->SetLineWidth( 2 );
    h1->SetLineColor( kBlack );
    h1->Draw();

}

void myVersion( ) {

	assign_value();
	
	 
	printf( "ymin = %15.10e\n", yy[0] );
	printf( "ymax = %15.10e\n", yy[1999] );

	testFill();
	testSpeed();

}
