#include <iostream>
#include <chrono> 
#include <bitset>
using namespace std;

static long int x = 1;  // 0000000000000001

 
void f_call_static( ){ 
    x = x << 10;  // 0000010000000000
    x = x >> 10;  // 0000000000000001
}


void f_call_local( long int & y ){
    y = y << 10;  // 0000010000000000
    y = y >> 10;  // 0000000000000001
}

int main( ) {

    
    auto start0 = std::chrono::high_resolution_clock::now();
    for (long int i = 0; i < 200000000; ++i)
    {
       f_call_static();
        
    }
    auto finish0 = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> elapsed0 = finish0 - start0 ;
    printf("Elapsed time: %.3f s (%s)\n", elapsed0.count(), "static variable" );


    long int y = 1;
    auto start1 = std::chrono::high_resolution_clock::now();
    for( long int ii =0; ii< 200000000; ii++) {
        f_call_local( y );
    }
    auto finish1 = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> elapsed1 = finish1 - start1;
    printf("Elapsed time: %.3f s (%s)\n", elapsed1.count(), "local variable" );


	return 0;
}
