
//========================================= for random generator between [0,1]
static unsigned long jz;
static unsigned long jsr=123456789; // seed
#define SHR3 (jz=jsr, jsr^=(jsr<<13), jsr^=(jsr>>17), jsr^=(jsr<<5),jz+jsr)
#define UNI (.5 + (signed) SHR3*.2328306e-9) 
//=============================================================================

double pdf( double x ){

    //double simga  = 1.;
    //double cetner = 0.;
    //PI = ROOT.TMath.Pi()
    // term1 = ( x - cetner )**2 / 2. / simga**2 

    return   TMath::Exp( -0.5*x*x );


}
    


double sampling( double xmin, double xmax, double ymin, double ymax ){

    while( 1 ){

         double x_r = UNI*( xmax-xmin) + xmin;

         double y = pdf( x_r );

         double y_r = UNI*( ymax-ymin) + ymin;

         if( y > y_r ){ return x_r; }
    }
}

void testSpeed();
void testFill();


void rejection_method( ){


    testSpeed();
    testFill();

}



void testSpeed(){
    
    auto start = std::chrono::high_resolution_clock::now();
    for( int ix = 0; ix<1000000; ix++ ){

        double value = sampling(-5,5,0,1); 
    }
    auto finish = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double> elapsed = finish - start;
    printf("Elapsed time: %.5f ms (%s)\n", elapsed.count()*1000, "rejection method" );
}

void testFill(){
    
    TH1D* h1 = new TH1D( "h1", "h1", 1000, -5, 5 );
 
    for( int ix = 0; ix<1000000; ix++ ){

        h1->Fill( sampling(-5,5,0,1) );
    }
 
    h1->SetLineWidth( 2 );
    h1->SetLineColor( kBlack );
    h1->Draw();
}
